function experimento = coloreadoCascada(datosPrograma, estadoSistema, nIteraciones4, nIteraciones3, traza)
cadena = 'Fase 1';
experimento_4colores = coloreadoFase(datosPrograma, estadoSistema, nIteraciones4, traza, cadena);

datos3colores = datosPrograma;
nIteraciones1Fase = experimento_4colores.nIteraciones;
densidadMetas = experimento_4colores.densidadMeta(nIteraciones1Fase, :);
densidadMinima = min(densidadMetas);
idx = find(densidadMetas == densidadMinima);
metaMenosDensa = eligeUno(idx);
nMetas = datos3colores.parametrosMetas.nMetas;
metas3colores = setdiff(1:nMetas, metaMenosDensa);

datos3colores.parametrosMetas.nMetas = nMetas - 1;
datos3colores.parametrosMetas.posicion = datos3colores.parametrosMetas.posicion(metas3colores, :);

colores = experimento_4colores.coloreado;
pierdenMeta = find(colores == metaMenosDensa);

estadoSistema = experimento_4colores.estadoSistema;

posicion = estadoSistema.posicion;
posicionObjetivo = estadoSistema.posicionObjetivo;

mundo = datosPrograma.mundo;
nElementos = length(pierdenMeta);
posicion(pierdenMeta, :) = puntosEnMundo(nElementos, mundo);
posicionMetas = datos3colores.parametrosMetas.posicion;
tipoHorizonte = datos3colores.tipoHorizonte;
for i = 1:nElementos,
    elemento = pierdenMeta(i);
    posicionObjetivo(elemento, :) = inicializaObjetivos(mundo, tipoHorizonte, posicion(elemento, :), posicionMetas);
end

estadoSistema.posicion = posicion;
estadoSistema.posicionObjetivo = posicionObjetivo;

cadena = 'Fase 2';
experimento_3colores = coloreadoFase(datos3colores, estadoSistema, nIteraciones3, traza, cadena);
    
experimento = [];
experimento.colores4 = experimento_4colores;
experimento.colores3 = experimento_3colores;